Draft Text
|
Menu location |
---|
Annotation → Text |
Workbenches |
Draft, BIM |
Default shortcut |
T E |
Introduced in version |
0.7 |
See also |
Draft Label, Draft ShapeString |
Description
The Draft Text command creates a multi-line text at a given point.
To create a text element with an arrow use the Draft Label command instead.
Single point required to position the text
Usage
See also: Draft Tray and Draft Snap.
- There are several ways to invoke the command:
- Press the
Text button.
- Select the Annotation →
Text option from the menu.
- Use the keyboard shortcut: T then E.
- Press the
- The Text task panel opens. See Options for more information.
- Pick a point in the 3D view, or type coordinates and press the
Enter point button.
- Enter the desired text, press Enter to start a new line.
- Press Enter twice or press the
Create text button to finish the command.
Options
The single character keyboard shortcuts available in the task panel can be changed. See Draft Preferences. The shortcuts mentioned here are the default shortcuts (for version 1.0).
- To manually enter coordinates enter the X, Y and Z component, and press Enter after each. Or you can press the
Enter point button when you have the desired values. It is advisable to move the pointer out of the 3D view before entering coordinates.
- Press G or click the Global checkbox to toggle global mode. If global mode is on, coordinates are relative to the global coordinate system, else they are relative to the working plane coordinate system. introduced in version 0.20
- Press N or click the Continue checkbox to toggle continue mode. If continue mode is on, the command will restart after finishing, allowing you to continue creating texts. The shortcut does not work in the second task panel. This option is not available in the first task panel in FreeCAD version 0.19 and earlier.
- Press S to switch Draft snapping on or off.
- Press Esc or the Close button to abort the command.
Notes
- A Draft Text can be edited by double-clicking it in the Tree view. introduced in version 0.20
- Draft Texts created or saved with FreeCAD version 0.21 are not backward compatible.
Properties
See also: Property editor.
A Draft Text object is derived from an App FeaturePython object and inherits all its properties. The following properties are additional unless otherwise stated.
Data
Base
- DataPlacement (
Placement
): specifies the position of the text in the 3D view. See Placement. - DataText (
StringList
): specifies the contents of the text. Each item in the list represents a new text line.
View
Annotation
- ViewAnnotation Style (
Enumeration
): specifies the annotation style applied to the text. See Draft AnnotationStyleEditor. - ViewScale Multiplier (
Float
): specifies the general scaling factor applied to the text.
Display Options
- ViewDisplay Mode (
Enumeration
): specifies how the text is displayed. If it isWorld
the text will be displayed on a plane defined by its DataPlacement. If it isScreen
the text will always face the screen. This is an inherited property. The mentioned options are the renamed options (introduced in version 0.21).
Graphics
- ViewLine Color (
Color
): not used. - ViewLine Width (
Float
): not used.
Text
- ViewFont Name (
Font
): specifies the font used to draw the text. It can be a font name, such asArial
, a default style such assans
,serif
ormono
, a family such asArial,Helvetica,sans
, or a name with a style such asArial:Bold
. If the given font is not found on the system, a default font is used instead. - ViewFont Size (
Length
): specifies the size of the letters. The text can be invisible in the 3D view if this value is very small. - ViewJustification (
Enumeration
): specifies if the alignment of the text:Left
,Center
orRight
. - ViewLine Spacing (
Float
): specifies the factor applied to the default line height of the text. - ViewText Color (
Color
): specifies the color of the text.
Scripting
See also: Autogenerated API documentation and FreeCAD Scripting Basics.
To create a Draft Text use the make_text
method (introduced in version 0.19) of the Draft module. This method replaces the deprecated makeText
method.
text = make_text(string, placement=None, screen=False)
- Creates a
text
object, atplacement
, which can be aFreeCAD.Placement
, but also aFreeCAD.Rotation
or aFreeCAD.Vector
. string
is a string or a list of strings. If it is a list, each element is displayed on its own line.- If
screen
isTrue
, the text always faces the camera, otherwise it is displayed in a plane defined by its DataPlacement.
The view properties of text
can be changed by overwriting its attributes; for example, overwrite ViewObject.FontSize
with the new size in millimeters.
Example:
import FreeCAD as App
import Draft
doc = App.newDocument()
t1 = "This is a sample text"
p1 = App.Vector(0, 0, 0)
t2 = ["First line", "second line"]
p2 = App.Vector(1000, 1000, 0)
text1 = Draft.make_text(t1, p1)
text2 = Draft.make_text(t2, p2)
text1.ViewObject.FontSize = 200
text2.ViewObject.FontSize = 200
zaxis = App.Vector(0, 0, 1)
t3 = ["Upside", "down"]
p3 = App.Vector(-1000, -500, 0)
place3 = App.Placement(p3, App.Rotation(zaxis, 180))
text3 = Draft.make_text(t3, place3)
text3.ViewObject.FontSize = 200
doc.recompute()
- Drafting: Line, Polyline, Fillet, Arc, Arc by 3 points, Circle, Ellipse, Rectangle, Polygon, B-spline, Cubic Bézier curve, Bézier curve, Point, Facebinder, ShapeString, Hatch
- Annotation: Text, Dimension, Label, Annotation styles, Annotation scale
- Modification: Move, Rotate, Scale, Mirror, Offset, Trimex, Stretch, Clone, Array, Polar array, Circular array, Path array, Path link array, Point array, Point link array, Edit, Subelement highlight, Join, Split, Upgrade, Downgrade, Wire to B-spline, Draft to sketch, Set slope, Flip dimension, Shape 2D view
- Draft Tray: Select plane, Set style, Toggle construction mode, AutoGroup
- Snapping: Snap lock, Snap endpoint, Snap midpoint, Snap center, Snap angle, Snap intersection, Snap perpendicular, Snap extension, Snap parallel, Snap special, Snap near, Snap ortho, Snap grid, Snap working plane, Snap dimensions, Toggle grid
- Miscellaneous: Apply current style, Layer, Manage layers, Add a new named group, Move to group, Select group, Add to construction group, Toggle normal/wireframe display, Create working plane proxy, Heal, Show snap toolbar
- Additional: Constraining, Pattern, Preferences, Import Export Preferences, DXF/DWG, SVG, OCA, DAT
- Context menu:
- Layer container: Merge layer duplicates, Add new layer
- Layer: Activate this layer, Select layer contents
- Text: Open hyperlinks
- Wire: Flatten
- Working plane proxy: Write camera position, Write objects state

- Getting started
- Installation: Download, Windows, Linux, Mac, Additional components, Docker, AppImage, Ubuntu Snap
- Basics: About FreeCAD, Interface, Mouse navigation, Selection methods, Object name, Preferences, Workbenches, Document structure, Properties, Help FreeCAD, Donate
- Help: Tutorials, Video tutorials
- Workbenches: Std Base, Assembly, BIM, CAM, Draft, FEM, Inspection, Material, Mesh, OpenSCAD, Part, PartDesign, Points, Reverse Engineering, Robot, Sketcher, Spreadsheet, Surface, TechDraw, Test Framework
- Hubs: User hub, Power users hub, Developer hub